#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_BuffCFG.h"
std::auto_ptr<Fish_BuffCFG> Fish_BuffCFG::msSingleton(nullptr);

int Fish_BuffCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_BuffCFGData* Fish_BuffCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_BuffCFGData>& Fish_BuffCFG::GetMapData()
{
	return mMapData;
}

void Fish_BuffCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_BuffCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_BuffCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mBuffName = element->Attribute("BuffName");
		data.mBuffIcon = element->Attribute("BuffIcon");
		data.mBuffType = element->IntAttribute("BuffType");
		data.mDuration = element->IntAttribute("Duration");
		data.mNeedVIP = element->IntAttribute("NeedVIP");
		data.mBulletType = element->IntAttribute("BulletType");
		data.mBulletCount = element->IntAttribute("BulletCount");
		{
			const char* Param = element->Attribute("Param");
			std::vector<std::string> vecParam;
			boost::split(vecParam, Param, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecParam[i].c_str(), &temp))
				{
					data.mParam.push_back(temp);
				}
			}
		}
		data.mGuideImage = element->Attribute("GuideImage");
		data.mGuideInfo = element->Attribute("GuideInfo");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_BuffCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_BuffCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_BuffCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_BuffCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_BuffCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "BuffName", data.mBuffName);
		LuaCfgHelper::readString(L, "BuffIcon", data.mBuffIcon);
		LuaCfgHelper::readInt(L, "BuffType", data.mBuffType);
		LuaCfgHelper::readInt(L, "Duration", data.mDuration);
		LuaCfgHelper::readInt(L, "NeedVIP", data.mNeedVIP);
		LuaCfgHelper::readInt(L, "BulletType", data.mBulletType);
		LuaCfgHelper::readInt(L, "BulletCount", data.mBulletCount);
		LuaCfgHelper::readVectorInt(L, "Param", data.mParam);
		LuaCfgHelper::readString(L, "GuideImage", data.mGuideImage);
		LuaCfgHelper::readString(L, "GuideInfo", data.mGuideInfo);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_BuffCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_BuffCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_BuffCFG* Fish_BuffCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_BuffCFG());
	}
	return msSingleton.get();
}

void Fish_BuffCFG::Release()
{
	msSingleton.reset(nullptr);
}
